//#define DEBUG_MODE_FULL
#include "script_component.hpp"

PARAMS_1(_unit);
private ["_a","_c","_i","_w","_t"];
#define __va configFile >> "ASR_Replacements" >> "CfgWeapons" >> _x
#define __vam missionConfigFile >> "ASR_Replacements" >> "CfgWeapons" >> _x
if (!isNil(QUOTE(GVAR(disabled)))) exitWith {LOG("DISABLED")};

/*

// config example
// condition can be missing and will be assumed true
 
class ASR_Replacements {
	class CfgWeapons {
		class BAF_L85A2_RIS_ACOG {
			variants[] = {"ACE_HK416_D14_ACOG_PVS14","ACE_HK416_D14_TWS"};
			condition = "_unit == leader _unit && (daytime > 21 || daytime < 5)"; // something better for the TL if the mission starts at night.
		};
		class M16A2GL {
			variants[] = {"M16A2GL","ACE_m16a2gl_scope"};
			condition = "typeOf _unit == 'TK_Special_Forces_EP1'"; // 50% chance the TK SF gets a scope for his M16A2
		};
	};
};

*/

{ // cycle unit's weapons
	if (isClass (__va) || isClass (__vam)) then {
		if (isClass (__vam)) then {
			_a = getArray(__vam  >> "variants");
			_t = if (isText(__vam  >> "condition")) then {call compile getText(__vam  >> "condition")} else {true};
		} else {
			_a = getArray(__va  >> "variants");
			_t = if (isText(__va  >> "condition")) then {call compile getText(__va  >> "condition")} else {true};
		};
		_c = count _a; // count variants
  	if (_c > 0) then { // if we have at least one choice
  		// if more than one pick random choice
  		_i = if (_c > 1) then {round random (_c - 1)} else {0};
  		// select new weapon
  		_w = _a select _i;
  		// if condition is met and it's really another weapon then switch
  		if (_t && toLower(_w) != toLower(_x) && isClass (configFile >> "CfgWeapons" >> _x)) then {
  			_unit removeWeapon _x;
  			_unit addWeapon _w;
  			_unit selectWeapon _w;
  			//TRACE_3("Replaced",_unit,_x,_w);
  		};
  	} else {
  		LOG("EMPTY ARRAY");
  	};
	};//isClass
} foreach weapons _unit;

// select first primary weapon muzzle (making sure, doesn't hurt ;)
if (isClass(configFile >> "CfgFunctions" >> "CBA" >> "Misc" >> "selectWeapon")) then {
	[_unit, primaryWeapon _unit] call CBA_fnc_selectWeapon;
};
